//
//  SelfieInstructionsRouter.swift
//  Pods
//
//  Created by Juan Carlos Pérez on 1/30/19.
//  Copyright (c) 2019 ___ORGANIZATIONNAME___. All rights reserved.
//
//  This file was generated by the Clean Swift Xcode Templates so
//  you can apply clean architecture to your iOS and Mac projects,
//  see http://clean-swift.com
//

import UIKit

@objc protocol SelfieInstructionsRoutingLogic
{
    func routeToTakeSelfie(segue: UIStoryboardSegue?)
    func routeToShowPreview(segue: UIStoryboardSegue?)
}

protocol SelfieInstructionsDataPassing
{
  var dataStore: SelfieInstructionsDataStore? { get }
}

class SelfieInstructionsRouter: NSObject, SelfieInstructionsRoutingLogic, SelfieInstructionsDataPassing
{

  weak var viewController: SelfieInstructionsViewController?
  var dataStore: SelfieInstructionsDataStore?
  
  // MARK: Routing
    func routeToTakeSelfie(segue: UIStoryboardSegue?) {
        if let segue = segue {
            let destinationVC = segue.destination as! SelfieViewController
            var destinationDS = destinationVC.router!.dataStore!
            passDataToTakeSelfie(source: dataStore!, destination: &destinationDS)
        } else {
            let destinationVC = viewController?.storyboard?.instantiateViewController(withIdentifier: "selfieViewId") as! SelfieViewController
            var destinationDS = destinationVC.router!.dataStore!
            passDataToTakeSelfie(source: dataStore!, destination: &destinationDS)
            navigateToTakeSelfie(source: viewController!, destination: destinationVC)
        }
    }
    

    func routeToShowPreview(segue: UIStoryboardSegue?) {
        if let segue = segue {
            let destinationVC = segue.destination as! SelfiePreviewViewController
            var destinationDS = destinationVC.router!.dataStore!
            passDataToShowSelfie(source: dataStore!, destination: &destinationDS)
        } else {
            let destinationVC = viewController?.storyboard?.instantiateViewController(withIdentifier: "selfiePreviewViewId") as! SelfiePreviewViewController
            var destinationDS = destinationVC.router!.dataStore!
            passDataToShowSelfie(source: dataStore!, destination: &destinationDS)
            navigateToShowSelfie(source: viewController!, destination: destinationVC)
        }
    }
    
    
    // MARK: Navigation
    func navigateToTakeSelfie(source: SelfieInstructionsViewController, destination: SelfieViewController){
        destination.delegate = source
        
        let navigationController = UINavigationController(rootViewController: destination)
        navigationController.isNavigationBarHidden = true
        navigationController.modalPresentationStyle = UIModalPresentationStyle.overCurrentContext
        
        let rootViewController = UIApplication.shared.keyWindow?.rootViewController
        rootViewController?.present(navigationController, animated: true, completion: nil)
    }
    
    
    func navigateToShowSelfie(source: SelfieInstructionsViewController, destination: SelfiePreviewViewController){
        //source.show(destination, sender: nil)
        source.navigationController?.pushViewController(destination, animated: false)
    }

    
    // MARK: Passing data
    func passDataToTakeSelfie(source: SelfieInstructionsDataStore, destination: inout SelfieDataStore){
        let showFrontCamera = source.showFrontCamera
        destination.showFrontCamera = showFrontCamera
    }
    
    
    func passDataToShowSelfie(source: SelfieInstructionsDataStore, destination: inout SelfiePreviewDataStore){
        let imgSelfie = source.imgPhoto
        destination.imgSelfie = imgSelfie
    }
    
}
